////////////////////////////////////////////////////////////////////////////////
// サムネイルビュー
//   Copyright(C) 2008-2009 せりか/せりか式
////////////////////////////////////////////////////////////////////////////////

album.view.ThumbnailView = {
	contentarea: null,
	create: function(area) {
		var x = document.createElement("div");
			x.appendChild(document.createTextNode("Sort: "));
		var a = document.createElement("a");
			a.appendChild(document.createTextNode("name"));
			a.href = "#";
			album.util.addEvent(a, 'mousedown', album.util.closure(this._sort, 'name'));
			x.appendChild(a);
			x.appendChild(document.createTextNode(" "));
		a = document.createElement("a");
			a.appendChild(document.createTextNode("size"));
			a.href = "#";
			album.util.addEvent(a, 'mousedown', album.util.closure(this._sort, 'size'));
			x.appendChild(a);
			x.appendChild(document.createTextNode(" "));
		a = document.createElement("a");
			a.href = "#";
			a.appendChild(document.createTextNode("date"));
			album.util.addEvent(a, 'mousedown', album.util.closure(this._sort, 'date'));
			x.appendChild(a);

		area.appendChild(x);

		this.contentarea = document.createElement('div');
//		this.contentarea.style.border = "1px solid black";
		area.appendChild(this.contentarea);
		this.reset(this.contentarea);
		return true;
	},
	reset: function(view) {
		var obja, obji, img;
		for(var i in album.imgs){
			img = album.imgs[i];

			obji = document.createElement('img');
			obji.src = img['thumbnail'];
			obji.id = '_ThumbnailView_'+img['index'];
			obji.setAttribute('title', img['name']);

			obja = document.createElement('a');
			obja.href = '#';
			obja.id = 'a_'+img['index'];
				album.util.addEvent(obja, 'mouseover', album.util.closure(this._mouseover, img['index']));
				album.util.addEvent(obja, 'mouseout',  album.util.closure(this._mouseout,  img['index']));

			album.util.addEvent(obja, 'mousedown', album.util.closure(mousedown, img['index']) );
			album.util.addEvent(obja, 'dblclick',  album.util.closure(dblclick,  img['index']) );

			obja.appendChild(obji);
			view.appendChild(obja);
		}
	},
	selectItem: function(idx, isSelected) {
		var img = album.getimage(idx);
		idx = img["index"];
		var obj = document.getElementById('_ThumbnailView_'+idx);
		if(obj){
			if(isSelected) album.util.addClass(obj, 'selected');
			else           album.util.delClass(obj, 'selected');
		}
	},
	resize: function(width, height) {
		var obj = document.getElementById('ThumbnailView');
		if(obj) obj.style.height = height-8+'px';
	},
	last: 'name',
	asc : 0,
	_sort: function(e, col){
		var TV = album.view.ThumbnailView;

		if(col == TV.last) TV.asc = 1 - TV.asc;
		else               TV.asc = 0;
		TV.last = col;
		var type = 'str';
		if(col == 'size') type = 'num';

		var comp = '_compare_' + type + (TV.asc ? '_asc' : '_dec');

		var img;
		var ary = new Array();
		for(var i in album.imgs){
			img = album.imgs[i];
			ary[i] = {'index':img['index'], 'value':img[col]};
		}
		// 
		var cache = new Array();
		var contentarea = TV.contentarea;
		while(contentarea.firstChild){
			cache[contentarea.firstChild.id] = contentarea.firstChild;
			contentarea.removeChild(contentarea.firstChild);
		}
		ary.sort(TV[comp]);
		for(var i in ary){
			contentarea.appendChild(cache['a_'+ary[i].index]);
		}

	},
	_compare_str_asc: function(val1, val2){
		return (val2.value.toLowerCase() == val1.value.toLowerCase()) ? 0 : (val2.value.toLowerCase() < val1.value.toLowerCase()) ? -1 : 1;
	},
	_compare_str_dec: function(val1, val2){
		return (val1.value.toLowerCase() == val2.value.toLowerCase()) ? 0 : (val1.value.toLowerCase() < val2.value.toLowerCase()) ? -1 : 1;
	},
	_compare_num_asc: function(val1, val2){
		return (parseFloat(val2.value) - parseFloat(val1.value));
	},
	_compare_num_dec: function(val1, val2){
		return (parseFloat(val1.value) - parseFloat(val2.value));
	},
	infownd: null,
	_mouseover : function (e, idx){
		if(this.infownd) return;

		var elem = e.srcElement || e.target;
		var doc  = elem.ownerDocument;
		var pos  = album.util.getPosition(elem);
		var img  = album.imgs[idx];

		this.infownd = doc.createElement('div');
//		this.thumbnail.src = album.imgs[idx]['thumbnail'];
		this.infownd.style.position = 'absolute';
		this.infownd.style.left = pos.x+60+'px';
		this.infownd.style.top  = pos.y+pos.h+1+'px';
		this.infownd.style.border = '1px solid black';
		this.infownd.style.backgroundColor = '#EFF1FF';
		var info = doc.createElement('p');
			info.style.margin  = '2px';
//			info.appendChild(doc.createTextNode(img['name']));
//			info.appendChild(doc.createElement('br'));
			info.appendChild(doc.createTextNode(img['date']));
		this.infownd.appendChild(info);

		doc.getElementsByTagName('body')[0].appendChild(this.infownd);
	},
	_mouseout : function (e, idx){
		if(this.infownd == null) return;

		var elem = e.srcElement || e.target;
		elem.ownerDocument.getElementsByTagName('body')[0].removeChild(this.infownd);
		this.infownd = null;
	}
}

